<?php
/**
 * This product Copyright 2010 metaVentis GmbH.  For detailed notice,
 * see the "NOTICE" file with this distribution.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
require_once ('../../conf.inc.php');
require_once (MC_LIB_PATH.'ESApp.php');
require_once (MC_LIB_PATH.'EsApplications.php');
require_once (MC_LIB_PATH.'EsApplication.php');
require_once (MC_LIB_PATH.'ESRepository.php');

require_once (MC_LIB_PATH.'ESModule.php');
require_once (MC_LIB_PATH.'ESObject.php');

require_once ('Alfresco/Service/Repository.php');
require_once ('Alfresco/Service/SpacesStore.php');

ini_set('log_errors', 1);

class qtiresult
{

	public function saveResultLocal($p_id,$res_file)
	{
		return $this->saveResult($p_id, $res_file);
	}

	public function saveResult($p_id,$res_file)
	{

		$ro = new stdClass();

		$file = '/tmp/'.$p_id.".zip";
		$fh = fopen($file, 'w+');
		if ( ! $fh )
		{
			error_log('Error opening result-file "'.$file.'".');
			return $ro->setTrackingReturn = false;
		}

		if ( ! fwrite($fh, $res_file) )
		{
			error_log('Error writing result-file "'.$file.'".');
			return $ro->setTrackingReturn = false;
		}

		fclose($fh);

		require_once(MC_LIB_PATH.'Plattform.php');
		$l_Plattform = new Plattform();

		$data_arr = explode("-", $p_id);

		$l_ins = ' insert into ESRESULT ('
			. $l_Plattform->DB->quoteIdentifier('ESRESULT_APP_ID')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_ESTRACK_ID')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_REP_ID')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_LMS_COURSE_ID')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_OBJECT_ID')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_NAME')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_MODUL_ID')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_MODUL_NAME')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_VERSION')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_USER_NAME')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_USER_ID')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_POINTS')
			.', ' . $l_Plattform->DB->quoteIdentifier('ESRESULT_FILE')
			.', ' . $l_Plattform->DB->quoteIdentifier('STATE')
			. ') values ('
			. $l_Plattform->DB->quote($data_arr[1], 'text')
			.', ' . $l_Plattform->DB->quote($data_arr[4], 'text')
			.', ' . $l_Plattform->DB->quote($data_arr[0], 'text')
			.', ' . $l_Plattform->DB->quote($data_arr[2], 'text')
			.', ' . $l_Plattform->DB->quote($data_arr[5], 'text')
			.', ' . $l_Plattform->DB->quote('', 'text')
			.', ' . $l_Plattform->DB->quote('', 'text')
			.', ' . $l_Plattform->DB->quote('', 'text')
			.', ' . $l_Plattform->DB->quote('', 'text')
			.', ' . $l_Plattform->DB->quote('', 'text')
			.', ' . $l_Plattform->DB->quote($data_arr[3], 'text')
			.', ' . $l_Plattform->DB->quote('', 'text')
			.', ' . $l_Plattform->DB->quote($file, 'text')
			.', ' . $l_Plattform->DB->quote('Y', 'text')
			.');';

		$res = $l_Plattform->DB->query($l_ins);
		if (Plattform::isError($res))
		{
			error_log('Error inserting result.');
			error_log( $res->getMessage() );

			// @see http://www.w3.org/TR/soap11/#_Toc478383529
			header('HTTP/1.1 500 Internal Server Error', true, 500);

			return $ro->setTrackingReturn = false;
		}

		$LastInsertId = $l_Plattform->DB->lastInsertID();
		if ( ! $LastInsertId )
		{
			error_log('Error reading last-insert-id.');

			// @see http://www.w3.org/TR/soap11/#_Toc478383529
			header('HTTP/1.1 500 Internal Server Error', true, 500);

			return $ro->setTrackingReturn = false;
		}

		return $ro->setTrackingReturn = $LastInsertId;
	}


}// end class

$server = new SoapServer("qtiresult.wsdl");
$server->setClass("qtiresult");
$server->handle();

