<?php
/**
 * This product Copyright 2010 metaVentis GmbH.  For detailed notice,
 * see the "NOTICE" file with this distribution.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
require_once("MDB2.php"); // from PEAR

//define('DBMC_FETCHMODE_ASSOC', DB_FETCHMODE_ASSOC);

define('DBMC_FETCHMODE_DEFAULT', MDB2_FETCHMODE_DEFAULT);
define('DBMC_FETCHMODE_ORDERED', MDB2_FETCHMODE_ORDERED);
define('DBMC_FETCHMODE_ASSOC',   MDB2_FETCHMODE_ASSOC);
define('DBMC_FETCHMODE_OBJECT',  MDB2_FETCHMODE_OBJECT);
define('DBMC_FETCHMODE_FLIPPED', MDB2_FETCHMODE_FLIPPED);

/**
* wrapper for PEAR DB class
*
* @author	Steffen Gross <gross@metacoon.net>
* @package 	classes.new
*/
class DBMC
{

	/**
	 *
	 * @var
	 */
	var $log = false;

	/**
	 *
	 * @var MDB2_Driver_Common
	 */
	var $DB;

	/**
	 * Constructor
	 *
	 * @author	Steffen Gross <gross@metaventis.comt>
	 * @package 	admin
	 */
	function DBMC($DB)
	{
		if (Plattform::isError($DB))
		{
			exit(0);
		}
		$this->DB = $DB;

		return true;
	}

	/**
	 *
	 */
	function &connect($p_dsn, $p_flag)
	{
		global $g_DBMC;

		if (is_object($g_DBMC) == false || strtolower(get_class($g_DBMC)) != 'dbmc')
		{
			$g_DBMC = new DBMC(MDB2::connect($p_dsn, $p_flag));
			$g_DBMC->setOption('field_case', CASE_UPPER);

			if ( 'mysql' == $g_DBMC->getPhptype() ) {
				$g_DBMC->query('set NAMES utf8');
			}
		}

		return $g_DBMC;
	}

	/**
	 *
	 */
	function &localConnect($p_dsn, $p_flag)
	{
		$l_DBMC = new DBMC(MDB2::connect($p_dsn, $p_flag));
		$l_DBMC->query('set NAMES utf8');

		return $l_DBMC;
	}

	/**
	 *
	 */
	function setOption($p_name, $p_value)
	{
		return $this->DB->setOption($p_name, $p_value);
	}

	/**
	 *
	 */
	function isError(&$p_object)
	{
		return MDB2::isError($p_object);
	}

	/**
	 *
	 */
	// mixed &query( string $query, [mixed $types = null], [mixed $result_class = true], [mixed $result_wrap_class = false])
	function &query($p_query, $p_types = null, $p_result_class = true, $p_result_wrap_class = false)
	{
		$this->log("\n\nquery:\n".$p_query);
		return $this->DB->query($p_query, $p_types, $p_result_class, $p_result_wrap_class);
	}

	/**
	 * method is deprecated (from deprecated package Pear::DB)
	 */
	function getOne($p_query)
	{
		$this->log("\n\nqueryOne:\n".$p_query);
		return $this->DB->queryOne($p_query);
	}

	/**
	 *
	 */
	// mixed queryOne( string $query, [string $type = null], [int $colnum = 0])
	function queryOne($p_query, $p_type = null, $p_column = 0)
	{
		$this->log("\n\nqueryOne:\n".$p_query);
		return $this->DB->queryOne($p_query, $p_type, $p_colnum);
	}

	/**
	 * method is deprecated (from deprecated package Pear::DB)
	 */
	function getCol($p_query)
	{
		$this->log("\n\nqueryCol:\n".$p_query);
		return $this->DB->queryCol($p_query);
	}

	/**
	 *
	 */
	// mixed queryCol( string $query, [string $type = null], [int $colnum = 0])
	function queryCol($p_query, $p_type = null, $p_column = 0)
	{
		$this->log("\n\nqueryCol:\n".$p_query);
		return $this->DB->queryCol($p_query, $p_type, $p_column);
	}

	/**
	 * method is deprecated (from deprecated package Pear::DB)
	 */
	function getRow($p_query, $p_fetchmode = DBMC_FETCHMODE_DEFAULT)
	{
		$this->log("\n\nqueryRow:\n".$p_query);
		return $this->DB->queryRow($p_query, null, $p_fetchmode);
	}


	/**
	 *
	 */
	// mixed mixed queryRow( string $query, [array $types = null], [int $fetchmode = MDB2_FETCHMODE_DEFAULT])
	function queryRow($p_query, $p_types = null, $p_fetchmode = DBMC_FETCHMODE_DEFAULT)
	{
		$this->log("\n\nqueryRow:\n".$p_query);
		return $this->DB->queryRow($p_query, $p_types, $p_fetchmode);
	}


	/**
	 * method is deprecated (from deprecated package Pear::DB)
	 */
	function getAll($p_query, $p_fetchmode = DBMC_FETCHMODE_DEFAULT)
	{
		$this->log("\n\nqueryAll:\n".$p_query);
		return $this->DB->queryAll($p_query, null, $p_fetchmode);
	}

	/**
	 *
	 */
	// mixed queryAll( string $query, [array $types = null], [int $fetchmode = MDB2_FETCHMODE_DEFAULT], [bool $rekey = false], [bool $force_array = false], [bool $group = false])
	function queryAll($p_query, $p_types = null, $p_fetchmode = DBMC_FETCHMODE_DEFAULT, $p_rekey = false, $p_force_array = false, $p_group = false)
	{
		$this->log("\n\nqueryAll:\n".$p_query);
		return $this->DB->queryAll($p_query, $p_types, $p_fetchmode, $p_rekey, $p_force_array, $p_group);
	}

	/**
	 *
	 */
	// mixed lastInsertID( [string $table = null], [string $field = null])
	function lastInsertID($p_table = null, $p_field = null)
	{
		return $this->DB->lastInsertID($p_table, $p_field);
	}

	/**
	 *
	 */
	// mixed &prepare( string $query, [mixed $types = null], [mixed $result_types = null], [mixed $lobs = array()])
	function &prepare($p_query)
	{
		$this->log("\n\nprepare:\n".$p_query);
		return $this->DB->prepare($p_query);
	}

	/**
	 *
 	 */
	function execute($p_prepare, $p_values)
	{
		if (is_object($p_prepare))
		{
			$this->log("\n\nexecute:\n".$p_query);
			return $p_prepare->execute($p_values);
		}
		return Plattform::error($p_prepare, 'statement is not an object');
	}

	/**
	 *
	 */
	// string quote( string $value, [string $type = null], [bool $quote = true], [bool $escape_wildcards = false])
	function quote($p_value, $p_type = null, $p_quote = true, $p_escape_wildcards = false)
	{
		return $this->DB->quote($p_value, $p_type, $p_quote, $p_escape_wildcards);
	}

	// function quoteIdentifier($str, $check_option = false)
	function quoteIdentifier($Identifier)
	{
		return $this->DB->quoteIdentifier($Identifier);
	}

	/**
	 * method is deprecated (from deprecated package Pear::DB)
	 */
	// array &getAssoc( string $query, [bool $force_array = false], [mixed $params = array()], [int $fetchmode = DB_FETCHMODE_DEFAULT], [bool $group = false])
	function getAssoc($p_query, $p_force_array = false, $p_params = array(), $p_fetchmode = DBMC_FETCHMODE_DEFAULT, $p_group = false)
	{
		/*
			from Pear::DB documentation :
			string  $query        the SQL query
			bool    $force_array  used only when the query returns exactly two columns. If true, the values of the returned array will be one-element arrays instead of scalars.
			mixed   $params       array, string or numeric data to be used in execution of the statement. Quantity of items passed must match quantity of placeholders in query: meaning 1 placeholder for non-array parameters or placeholder per array element.
			int     $fetchmode    the fetch mode to use
			bool    $group        if true, the values of the returned array is wrapped in another array. If the same key value (in the first column) repeats itself, the values will be appended to this array instead of overwriting the existing values.
		*/
		$this->log("\n\nqueryAll:\n".$p_query);
		return $this->DB->queryAll($p_query, null, $p_fetchmode, false, $p_force_array, $p_group);
	}

	/**
	 * loggin method for database actions
	 */
	function log($p_txt)
	{
		if (!$this->log) { return; }
		$handle = fopen(MC_ROOT_PATH.'error/debug/db.log.txt', 'a');
		fwrite($handle, microtime()."\n".$p_txt."\n( from ".$_SERVER['SCRIPT_FILENAME']." )\n\n");
		fclose($handle);
		return ;
	}

	public function getPhptype()
	{
		$PhpType = $this->DB->phptype;
		if ( ! $PhpType )
		{
			throw new Exception('No phptype available.');
		}

		return $PhpType;
	}

}
