<?php

/**
 *
 *
 *
 */
class ESRender_LicenseFactory_Implementation
implements ESRender_LicenseFactory_Interface
{

	/**
	 * (non-PHPdoc)
	 * @see ESRender_LicenseFactory_Interface::getLicense()
	 */
	public function getLicense($Name, $Author)
	{
		$License = null;

		$IconUrl = MC_SCHEME . '://' . MC_HOST . MC_PATH . '/theme/default/license/';
		switch( strtoupper($Name) )
		{
			case ESRender_License_Interface::COMMON_LICENSE_CUSTOM:
				$IconUrl .= ESRender_License_Interface::COMMON_LICENSE_CUSTOM . '.png';
				$License = new ESRender_License_Edusharing($Name, $Author, $IconUrl);
				break;

			case ESRender_License_Interface::COMMON_LICENSE_EDU_NC:
				$IconUrl .= ESRender_License_Interface::COMMON_LICENSE_EDU_NC . '.png';
				$License = new ESRender_License_Edusharing($Name, $Author, $IconUrl);
				break;

			case ESRender_License_Interface::COMMON_LICENSE_EDU_NC_ND:
				$IconUrl .= ESRender_License_Interface::COMMON_LICENSE_EDU_NC_ND . '.png';
				$License = new ESRender_License_Edusharing($Name, $Author, $IconUrl);
				break;

			case ESRender_License_Interface::COMMON_LICENSE_EDU_P_NR:
				$IconUrl .= ESRender_License_Interface::COMMON_LICENSE_EDU_P_NR . '.png';
				$License = new ESRender_License_Edusharing($Name, $Author, $IconUrl);
				break;

			case ESRender_License_Interface::COMMON_LICENSE_EDU_P_NR_ND:
				$IconUrl .= ESRender_License_Interface::COMMON_LICENSE_EDU_P_NR_ND . '.png';
				$License = new ESRender_License_Edusharing($Name, $Author, $IconUrl);
				break;

			case ESRender_License_Interface::CC_BY:
				$Url = 'http://creativecommons.org/licenses/by/3.0/';
				$IconUrl .= 'creative_commons/by.png';
				$License = new ESRender_License_CreativeCommons($Name, $Author, $IconUrl, $Url);
				break;

			case ESRender_License_Interface::CC_BY_NC:
				$Url = 'http://creativecommons.org/licenses/by-nc/3.0/';
				$IconUrl .= 'creative_commons/by-nc.png';
				$License = new ESRender_License_CreativeCommons($Name, $Author, $IconUrl, $Url);
				break;

			case ESRender_License_Interface::CC_BY_NC_ND:
				$Url = 'http://creativecommons.org/licenses/by-nc-nd/3.0/';
				$IconUrl .= 'creative_commons/by-nc-nd.png';
				$License = new ESRender_License_CreativeCommons($Name, $Author, $IconUrl, $Url);
				break;

			case ESRender_License_Interface::CC_BY_NC_SA:
				$Url = 'http://creativecommons.org/licenses/by-nc-sa/3.0/';
				$IconUrl .= 'creative_commons/by-nc-sa.png';
				$License = new ESRender_License_CreativeCommons($Name, $Author, $IconUrl, $Url);
				break;

			case ESRender_License_Interface::CC_BY_ND:
				$Url = 'http://creativecommons.org/licenses/by-nd/3.0/';
				$IconUrl .= 'creative_commons/by-nd.png';
				$License = new ESRender_License_CreativeCommons($Name, $Author, $IconUrl, $Url);
				break;

			case       ESRender_License_Interface::CC_BY_SA: 				     
			$Url        = 'http://creativecommons.org/licenses/by-sa/3.0/'; 				 
			$IconUrl   .='creative_commons/by-sa.png'; 			     
	   	$License    = new	ESRender_License_CreativeCommons($Name, $Author, $IconUrl, $Url); break;

			default:
				error_log('Unhandled or unknown license.');
				return false;
		}

		return $License;
	}

}
