<?php
/**
 * This product Copyright 2010 metaVentis GmbH.  For detailed notice,
 * see the "NOTICE" file with this distribution.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

require_once 'Alfresco/Service/WebService/WebServiceFactory.php';
require_once 'ESApp.php';

class ESRepository {

	private $basename;
	private $Conf;
	private $app;

	public function __construct()
	{
		$this->app = new ESApp();
	}

  public function getTicket($p_alf_app_id)
  {
	$this->app->getApp('esmain');
	$rep_conf = $this->app->getAppByID($p_alf_app_id);
	$ticket = $this->app->GetTicketbyConf($rep_conf,$this->app->getHomeConf());

	return $ticket;
  }

  public function GetTicketByUser($username,$useremail){

  	$this->app->getApp('esmain');
  	return $this->app->GetTicketByUser($username,$useremail);

  	}


	public function checkUsage($p_data,$p_alf_app_id)
	{
		$remote_app = $this->app->getAppByID($p_alf_app_id);

		try
		{
			$SoapClientParams = array();
			if ( defined('USE_HTTP_PROXY') && USE_HTTP_PROXY )
			{
			        $SoapClientParams = array(
			                'proxy_host' => HTTP_PROXY_HOST,
			                'proxy_port' => HTTP_PROXY_PORT,
			                'proxy_login' => HTTP_PROXY_USER,
			                'proxy_password' => HTTP_PROXY_PASS,
			        );
			}

			if ( empty($remote_app->prop_array['usagewebservice_wsdl']) )
			{
				throw new Exception('Missiong config-entry "usagewebservice_wsdl".');
			}

			$client = new SoapClient($remote_app->prop_array['usagewebservice_wsdl'], $SoapClientParams);

			$params = array("repositoryTicket" => $p_data['repositoryTicket'],
							"repositoryUsername"=> $p_data['repositoryUsername'],
							"lmsId"=> $p_data['lmsId'],
							"courseId"=> $p_data['courseId'],
							"parentNodeId"=> $p_data['parentNodeId'],
							"appUser"=> $p_data['appUser'],
							"resourceId"=> $p_data['resourceId']);

			$result = $client->getUsage($params);

			if ( empty($result->getUsageReturn) )
			{
				return false;
			}

			return $result;
		}
		catch (Exception $exception) {
			switch (1) {
				case (isSet($exception->detail->faultData->message)):
				$pos = strpos($exception->detail->faultData->message, 'Node does not exist');
				if ($pos === false) {
					$_exception = 'unbekannter Fehler.';
				}
				else{
					$_exception = 'Die Datei wurde im Repository geloescht.';
				}
			break;
			default:
				$_exception = "unbekannter Fehler ";
			}
		}

		return false;
	}

}

