<?php
/*
* $McLicense$
*
* $Id$
*
*/


class execute
	extends Step
{

	private $scheme = '';
	private $host   = '';
	private $base_uri = '';
	private $base_dir = '';

	private $db_drvr = '';
	private $db_host = '';
	private $db_port = '';
	private $db_name = '';
	private $db_user = '';
	private $db_pass = '';
	private $drop_db = '';

	private $repo_url = '';
	private $repo_host   = '';
	private $repo_scheme = '';
	private $repo_port   = '';
	private $repo_user   = '';
	private $repo_pwd    = '';

	private $data_dir = '';

	private $lang    = '';

	private $max_filesize = false;

	private $connect = false;

	private $default_memory_unit = 'M';

	private $ffmpeg_exec = '';
	function getFfmpegExec() { return $this->ffmpeg_exec; }

	private $flvtool_exec = '';
	function getFlvtoolExec() { return $this->flvtool_exec; }

	private $imagemagick_path = '';
	function getImageMagickPath() { return $this->imagemagick_path; }

	private $mencoder_exec = '';
	function getMencoderExec() { return $this->mencoder_exec; }

	/**
	 *
	 */
	function check($post)
	{
		if (empty($post['URL_SCHEME']))
		{
			$this->error(initdb_missing_form_data);
			return false;
		}

		$this->writeLog('_REQUEST', $post);

		$this->scheme = trim($post['URL_SCHEME']);
		$this->host   = trim($post['URL_HOST']);
		$this->base_uri = $this->normalizeUri($post['BASE_URI']);
		$this->base_dir = $this->normalizeDir($post['BASE_DIR']);

		$this->repo_url = ($post['REPO_URL']);

		$repo = parse_url($this->repo_url);
		$this->repo_host   = gethostbyname($repo['host']);
		$this->repo_scheme = $repo['scheme'];

    if (empty($repo['port'])){
	   	  $this->repo_port   = '80';
     	} else{
    		$this->repo_port   = $repo['port'];
     	};

		$this->repo_user   = $post['REPO_USER'];
		$this->repo_pwd    = $post['REPO_PWD'];

		$this->data_dir = $this->normalizeDir($post['DATA_DIR']);

		$this->db_drvr = 'mysql';
		$this->db_host = trim($post['DB_HOST']);
		$this->setDbPort($post['DB_PORT'], $this->db_drvr);
		$this->db_user = trim($post['DB_USER']);
		$this->db_pass = trim($post['DB_PASS']);
		$this->db_name = trim($post['DB_NAME']);

		$this->ffmpeg_exec = trim($post['FFMPEG']);
		$this->flvtool_exec = trim($post['FLVTOOL']);
		$this->imagemagick_path = trim($post['IMAGEMAGICK']);
		$this->mencoder_exec = trim($post['MENCODER']);

		$this->lang_id = empty($post['DEF_LANG']) ? 1 : intval($_REQUEST['DEF_LANG']);

		$this->drop_tab = empty($post['DROP_TAB']) ? false : true;

		$this->setMaxFilesize($post['MAX_FILESIZE']);

		// fetch mysql connection
		$this->DB = $this->getConnection();
		if ( ! $this->DB ) {
			return $this->error(install_err_db_access_denied);
		}

		return true;
	} // end method check



	/**
	 *
	 */
	function getScheme()  { return $this->scheme; }
	function getHost()    { return $this->host;   }
	function getBaseUri() { return $this->base_uri; }
	function getBaseDir() { return $this->base_dir; }


	function getRepoUrl()  { return $this->repo_url; }
	function getRepoHost() { return $this->repo_host; }
	function getRepoPort() { return $this->repo_port; }
	function getRepoUser() { return $this->repo_user; }
	function getRepoPwd()  { return $this->repo_pwd; }
	function getRepoScheme() { return $this->repo_scheme; }
	function getDataDir()  { return $this->data_dir; }


	/**
	 *
	 */
	function getDbDrvr() { return $this->db_drvr; }
	function getDbHost() { return $this->db_host; }
	function getDbPort() { return $this->db_port; }
	function getDbUser() { return $this->db_user; }
	function getDbPass() { return $this->db_pass; }
	function getDbName() { return $this->db_name; }



	/**
	 *
	 */
	function getLangId() { return $this->lang_id; }



	/**
	 *
	 */
	function getMaxFilesize() { return $this->max_filesize; }
	function getMaxPostsize() { return ($this->max_filesize + 5); }
	function getMemoryLimit() { return (2*$this->max_filesize + 10); }
	function getMemoryUnitDefault() { return $this->default_memory_unit; }



	/**
	 *
	 */
	function dropTablesIfExists() { return $this->drop_tab; }



	/**
	 *
	 */
	private function setDbPort($port, $driver=null) {
		// fetch mysql connection
		$port = trim($port);

		if ( empty($port) ) {
			$this->db_port = DBMC::getDefaultPort($driver);
		}
		else {
			$this->db_port = $port;
		}
	} // end function setDbPort



	/**
	 *
	 */
	private function setMaxFilesize($maxFilesize) {
		// fetch mysql connection
		$maxFilesize = intval($maxFilesize);

		if ( empty($maxFilesize) ) {
			$this->max_filesize = $this->max_filesize_default;
		}
		else {
			$this->max_filesize = $maxFilesize;
		}
	} // end function setMaxFilesize



	/**
	 *
	 */
	private function getConnection() {

		try
		{
			$connection = new DBMC($this->db_drvr, $this->db_host, $this->db_port, $this->db_user, $this->db_pass, $this->db_name);
			return $connection;
		}
		catch (Exception $e)
		{
			$this->error($e->getMessage());
			return false;
		}
	}



	/**
	 *
	 */
	function process($post)
	{
		require_once(INST_PATH_LIB."TemplateFile.php");

		try
		{
			$TmplFile = new TemplateFile();
			$TmplFile->copyTplDirectories($this);
//			$TmplFile->writeTplReplace($this);
//			$TmplFile->copyTplDirectories($this);
			return true;
		}
		catch (Exception $e)
		{
			// @TODO : error handling here (no rollback required, overwrite works)
			return false;
		}
	}



	/**
	 *
	 */
	function getPage($post, $p_step)
	{
/*
		require_once(INST_PATH_LIB . "Install.php");
		$install = new Install($this);

		if ($install->makeInstall() ) {
			echo "<hr>";
			$install->DB->query("update VERSION set UPDDAT=".time());
			$install->showInfo('<hr><span style="color:#00E000; font-size:12px; font-weight:bold;">'.install_complete.'</span>');
			$install->showInfo('<hr>'.sprintf(install_finish, INST_ROOT_PATH."install", '<a href="'.INST_URI.'" target="_top" style="color:#EB8C3B; font-weight:bold;">'.INST_URI.'</a>').'<p>');
		}
		else {
			longmsg(install_check_log.'.<p>');
			$install->showError(installation_canceled);
		}

		@TODO : information about .htaccess/move for password file, file manager, platform documents

*/
		$path = dirname(__FILE__);

		return sprintf(install_msg_all_done, $path, $this->base_uri);
	} // end method getPage


} // end class execute
