<?php
/*
* $McLicense$
*
* $Id$
*
*/


class initdb
	extends Step
{

	private $scheme = '';
	private $host   = '';
	private $base_uri = '';
	private $base_dir = '';
	#private $url = '';

	private $db_drvr = '';
	private $db_host = '';
	private $db_port = '';
	private $db_name = '';
	private $db_user = '';
	private $db_pass = '';
	private $drop_db = '';
	private $repo_url = '';
	private $repo_host = '';
	private $repo_port = '';
	private $repo_scheme = '';
	private $repo_user = '';
	private $repo_pwd = '';
	private $data_dir = '';

	// contains create statements of all tables
	private $all_tables = array();

	private $DB = false;

	private $db_srv_version = null;

	private $ffmpeg_exec = '';
	function getFfmpegExec() { return $this->ffmpeg_exec; }

	private $flvtool_exec = '';
	function getFlvtoolExec() { return $this->flvtool_exec; }

	private $imagemagick_path = '';
	function getImageMagickPath() { return $this->imagemagick_path; }

	private $mencoder_exec = '';
	function getMencoderExec() { return $this->mencoder_exec; }

	/**
	 *
	 */
	function check($post)
	{
		if (empty($post['URL_SCHEME']))
		{
			$this->error(initdb_missing_form_data);
			return false;
		}

		$this->writeLog('_REQUEST', $post);

		$this->scheme = trim($post['URL_SCHEME']);
		$this->host   = trim($post['URL_HOST']);
		$this->base_uri = $this->normalizeUri($post['BASE_URI']);
		$this->base_dir = $this->normalizeDir($post['BASE_DIR']);

		$this->db_drvr = 'mysql';
		$this->db_host = trim($post['DB_HOST']);
		$this->setDbPort($post['DB_PORT'], $this->db_drvr);
		$this->db_user = trim($post['DB_USER']);
		$this->db_pass = trim($post['DB_PASS']);
		$this->db_name = trim($post['DB_NAME']);

		$this->repo_url = trim($post['REPO_URL']);
		$repo = parse_url($this->repo_url);
		$this->repo_host   = gethostbyname($repo['host']);
		$this->repo_scheme = $repo['scheme'];

    if (empty($repo['port'])){
	   	  $this->repo_port   = '80';
     	} else{
    		$this->repo_port   = $repo['port'];
     	};

//echo $this->repo_port."<hr>";

		$this->repo_user= trim($post['REPO_USER']);
		$this->repo_pwd = trim($post['REPO_PWD']);
		$this->data_dir = trim($post['DATA_DIR']);

		$this->ffmpeg_exec = trim($post['FFMPEG']);
		$this->flvtool_exec = trim($post['FLVTOOL']);
		$this->imagemagick_path = trim($post['IMAGEMAGICK']);
		$this->mencoder_exec = trim($post['MENCODER']);

		$this->lang_id = empty($post['DEF_LANG']) ? 1 : intval($_REQUEST['DEF_LANG']);

		// value is 1 for table skipping, 0 for dropping
		$this->drop_tab = empty($post['DROP_TAB']) ? true : false;

		$this->setMaxFilesize($post);

		$this->DB = $this->getConnection();
		if ( ! $this->DB )
		{
			return $this->error(install_err_db_access_denied);
		}

		if ( ! is_writable(MC_BASE_DIR) )
		{
			return $this->error(sprintf(install_err_no_access, MC_BASE_DIR));
		}

		$this->db_srv_version = $this->DB->getVersion();

		$this->all_tables = $this->getAllTables();

		return true;
	} // end method check



	/**
	 *
	 */
	function getScheme()  { return $this->scheme; }
	function getHost()    { return $this->host;   }
	function getBaseUri() { return $this->base_uri; }
	function getBaseDir() { return $this->base_dir; }

	function getRepoUrl() { return $this->repo_url; }
	function getRepoHost() { return $this->repo_host; }
	function getRepoPort() { return $this->repo_port; }
	function getRepoScheme() { return $this->repo_scheme; }
	function getRepoUser() { return $this->repo_user; }
	function getRepoPwd() { return $this->repo_pwd; }
	function getDataDir() { return $this->data_dir; }



	/**
	 *
	 */
	function getDbDrvr() { return $this->db_drvr; }
	function getDbHost() { return $this->db_host; }
	function getDbPort() { return $this->db_port; }
	function getDbUser() { return $this->db_user; }
	function getDbPass() { return $this->db_pass; }
	function getDbName() { return $this->db_name; }

	/**
	 *
	 */
	function getLangId() { return $this->lang_id; }



	/**
	 *
	 */
	function dropTablesIfExists() { return $this->drop_tab; }



	/**
	 *
	 */
	private function setDbPort($port, $driver=null)
	{
		// fetch mysql connection
		$port = trim($port);

		if ( empty($port) ) {
			$this->db_port = DBMC::getDefaultPort($driver);
		}
		else {
			$this->db_port = $port;
		}
	}



	/**
	 *
	 */
	private function setMaxFilesize($post)
	{
		// fetch mysql connection
		if ( empty($post['MAX_FILESIZE']) )
		{
			global $default_max_filesize;
			$this->max_filesize = $default_max_filesize;
		}
		else
		{
			$this->max_filesize = $post['MAX_FILESIZE'];
		}
	}



	/**
	 *
	 */
	private function getConnection()
	{
		try
		{
			$connection = new DBMC($this->db_drvr, $this->db_host, $this->db_port, $this->db_user, $this->db_pass);
		}
		catch (Exception $e)
		{
			$this->error($e->getMessage());
			return false;
		}

		return $connection;
	}



	/**
	 *
	 */
	function process($post)
	{
		// create and select database
		$dbName = $this->getDbName();

		if ($this->createDb($dbName) && $this->DB->selectDb($dbName) )
		{
			$this->msg("database '{$dbName}' selected.");
		}

		$this->createTables();

		$this->loadTableContent();
/*

		$this->DB->writeSysConfig("DEFAULT_LANG", $this->getLangId());

		$check = $this->DB->getOne('select USER_ID from USER where USER_ID = 1');

		if (empty($check))
		{
			$this->error("administrator account does not exist! (empty tables?)", true);
			return false;
		}

		$qName = $this->DB->quote($this->admin_name);
		$qMail = $this->DB->quote($this->admin_mail);
		$qPass = $this->DB->quote( md5($this->admin_pass) );
		$qCrypt = $this->DB->quote( crypt($this->admin_pass, 'mc') );

		$upd = 'update USER set'
			.'  USER_NAME = ' . $qName
			.', USER_VORNAME  = "admin"'
			.', USER_NACHNAME  = "metacoon"'
			.', USER_SELECTNAME  = "metacoon SysAdmin"'
			.', USER_PWD  = ' . $qPass
			.', USER_PWD_CRYPT = ' . $qCrypt
			.', USER_EMAILADR  = ' . $qMail
			.' where USER_ID = 1'
		;
		$res = $this->DB->query($upd);

		$upd = 'update mc_phpbb_users set'
			.'  username = ' . $qName
			.', user_password = ' . $qPass
			.', user_email = ' . $qMail
			.' where user_id = 1'
		;
		$res = $this->DB->query($upd);

		$this->info(install_msg_admin_set);

		// remove passwords from log data
		$post['LOGIN_ADMIN_PASSWORD'] = null;
		$post['LOGIN_ADMIN_PASS_CONFIRM'] = null;
		$this->writeLog('_REQUEST', $post);
*/
		return true;
	}



	/**
	 *
	 */
	function getPage($post, $step)
	{
		$contents = file_get_contents('./_layout/initdb.lay');
		$replace = array(
		  '{step}' => $step,
		  '{intro}'    => install_intro,
		  '{form_name}'   => 'set_htaccess',
		  '{form_target}' => '_self',
		  '{form_action}' => 'install.php',
		  '{form_submit}' => install_save,

		  '{initdb_label_max_filesize}' => initdb_label_max_filesize,
		  '{max_filesize}' => $this->max_filesize,
		);

		return $this->replace($contents, $replace);
	}


	/**
	 * createDb
	 */
	function createDb($dbName)
	{
		if ($this->DB->dbExists($dbName) )
		{
			$this->msg( sprintf(initdb_database_exists, $dbName) );
			return true;
		}

		// create db
		$createState = $this->DB->createDb($dbName);
		if ($createState)
		{
			$this->info( sprintf(initdb_database_created, $dbName) );
			return true;
		}

		$this->error( sprintf(initdb_database_failed, $dbName) );
		return false;
	}



	/**
	 *
	 */
	function createTables()
	{
		// check for tables and create missing tables
		$skipped = array();
		$dropped = array();
		$created = array();

		foreach($this->all_tables as $name => $definition)
		{
			$qName = $this->DB->quote($name);
			$name = $this->DB->getOne('show tables like ' . $qName);

			if ($name)
			{
				if ( ! $this->dropTablesIfExists() )
				{
					$skipped[] = $name;
//					$this->msg('table "'.$name.'" already exists');
					continue;
				}

				$res = $this->DB->query('drop table '.$name);

				$dropped[] = $name;
			} // end if ($name)

			if ($this->db_srv_version < '5.1')
			{
				$definition = strtr($definition, array(
					'USING BTREE' => '',
				));
			}

			$res = $this->DB->query($definition);

			$created[] = $name;
//			$this->info('table "'.$name.'" created');
		} // end foreach($this->all_tables)

		if ( ! empty($skipped) )
		{
			$this->warning('creation of '.count($skipped).' table(s) skipped (requested by user if table already exists).');
		}

		if ( ! empty($dropped) )
		{
			$this->msg(count($dropped).' table(s) dropped (requested by user if table already exists).');
		}

		if ( ! empty($created) )
		{
			$this->info(count($created).' table(s) created.');
		}

		$this->writeLog('tables_skipped', $skipped);
		$this->writeLog('tables_dropped', $dropped);
		$this->writeLog('tables_created', $created);

		return true;
	} // end method createTables



	/**
	 *
	 */
	function loadTableContent()
	{
		$empty   = 0;
		$skipped = 0;
		$loaded  = 0;

		$tabs = $this->DB->getCol('show tables');

		$skip_list = $this->readLog('tables_skipped', array());
		$skip_list = array_flip($skip_list);

		// set values for token of $arrToken2Values
		// these are not in use for building an install! (therefore set to "");
		$TOKEN_SQL_MODE = '';
		$TOKEN_DEFAULT_LANG = '';

		// set values for $arrValues2Token and load token map
		$TOKEN_SCHEME   = $this->getScheme();
		$TOKEN_HOST     = $this->getHost();
		$TOKEN_BASE_URI = $this->getBaseUri();
		$TOKEN_BASE_DIR = $this->getBaseDir();

		$TOKEN_DBHOST   = $this->getDbHost();
		$TOKEN_DBUSER   = $this->getDbUser();
		$TOKEN_DBPASS   = $this->getDbPass();
		$TOKEN_DBPORT   = $this->getDbPort();
		$TOKEN_DBNAME   = $this->getDbName();

		$TOKEN_REPO_URL    = $this->getRepoUrl();
		$TOKEN_REPO_HOST   = $this->getRepoHost();
		$TOKEN_REPO_PORT   = $this->getRepoPort();
		$TOKEN_REPO_SCHEME = $this->getRepoScheme();
		$TOKEN_REPO_USER   = $this->getRepoUser();
		$TOKEN_REPO_PWD    = $this->getRepoPwd();
		$TOKEN_DATA_DIR    = $this->getDataDir();

		$TOKEN_FFMPEG_EXEC   = $this->getFfmpegExec();
		$TOKEN_FLVTOOL_EXEC = $this->getFlvtoolExec();
		$TOKEN_IMAGEMAGICK_PATH = $this->getImageMagickPath();
		$TOKEN_MENCODER_EXEC = $this->getMencoderExec();

		include(INST_PATH_INC.'token_maps.php');

		$arrTokenKeys = array_keys($arrToken2Values);
		$srcPath = INST_PATH_TMPL . 'sql' . DIRECTORY_SEPARATOR . $this->getDbDrvr() . DIRECTORY_SEPARATOR;

		foreach($tabs as $name)
		{
			$src = $srcPath . $name . '.sql';

			if ( ! file_exists($src) )
			{
				$empty++;
				continue;
			}

			if ( isset($skip_list[$name]) )
			{
				$skipped++;
				continue;
			}

			$insert = file_get_contents($src);
//			foreach($arrInsert as $idx => $insert)
//			{
				$insert = str_replace($arrTokenKeys, $arrToken2Values, $insert);

				try
				{
					$res = $this->DB->query($insert);
				}
				catch (Exception $e)
				{
					SysMsg::showError("error on inserting {$idx}. row in table {$name}");
					throw $e;
				}
//			}

			$loaded++;
		} // end foreach($tabs)

		if ($skipped) {
			$this->warning($skipped.' table(s) skipped (not created by current configuration process).');
		}

		if ($loaded) {
			$this->info('content of '.$loaded.' table(s) loaded.');
		}

		return true;
	} // end method loadTableContent



	/**
	 *
	 */
	function getAllTables()
	{
		$srcPath = INST_PATH_TMPL . 'sql' . DIRECTORY_SEPARATOR . $this->getDbDrvr() . DIRECTORY_SEPARATOR;

		$handle = opendir($srcPath);

		if ( ! $handle )
		{
			SysMsg::showError('can not open path "'.$srcPath.'"');
			return false;
		}

		$arrAllTables = array();

		while ( ($file = readdir($handle)) !== false)
		{
			$src = $srcPath . $file;

			if ( ! is_file($src) ) {
				continue;
			}

			$base = explode('.', $file);
			if (count($base) != 2) {
				continue;
			}

			if ($base[1] != 'ddl') {
				continue;
			}

			$tableName = $base[0];
			$arrAllTables[$tableName] = file_get_contents($src);
		} // end while

		closedir($handle);

		return $arrAllTables;
	} // end method getAllTables



} // end class initdb

