<?php

/**
 * Module to handle URL's.
 *
 *
 */
class mod_url
extends ESRender_Module_NonContentNode_Abstract
{

	/**
	 * "Display" the url by presentung a intermediate page announcing the
	 * redirect.
	 *
	 * (non-PHPdoc)
	 * @see ESRender_Module_Base::display()
	 */
	protected function display(
		EsApplication $RemoteApplication,
		array $requestData)
	{
		if ( empty($this->_ESOBJECT->AlfrescoNode->properties[$this->getUrlProperty()]) )
		{
			error_log('URL-property is empty.');
			return false;
		}

		$Url = $this->_ESOBJECT->AlfrescoNode->properties[$this->getUrlProperty()];

		$Template = $this->getTemplate();
		echo $Template->render('/module/url/display', array(
			'Url' => $Url,
		));

		return true;
	}

	/**
	 * The object's property containing the url.
	 *
	 * @var string
	 */
	var $UrlProperty = '{http://www.campuscontent.de/model/1.0}wwwurl';

	/**
	 * Set the name of the property which should contain the url of interest.
	 *
	 * @param string $UrlProperty
	 *
	 * @return mod_url
	 */
	public function setUrlProperty($UrlProperty)
	{
		assert( is_string($UrlProperty) );

		$this->UrlProperty = $UrlProperty;

		return $this;
	}

	/**
	 * Get the name of the property which should contain the url of interest.
	 *
	 * @return string
	 */
	protected function getUrlProperty()
	{
		return $this->UrlProperty;
	}

}
