<?php

require_once(dirname(__FILE__).'/../../conf.inc.php');

ini_set('error_reposrting', E_ALL);
ini_set('display_errors', 1);

$ConfigDir = dirname(__FILE__).'/../../conf/esmain/';

/**
 *
 * @param string $Filename
 *
 * @return array
 */
function loadConfigFile($Filename)
{
	$Dom = new DOMDocument('1.0');
	if ( ! $Dom->load($Filename) )
	{
		return false;
	}

	if( ! $Dom->documentElement->hasChildNodes() )
	{
		return false;
	}

	$Data = array();
	foreach( $Dom->documentElement->childNodes as $ChildNode )
	{
		if ( XML_ELEMENT_NODE == $ChildNode->nodeType )
		{
			if ( 'ENTRY' == strtoupper($ChildNode->localName) )
			{
				if ( $ChildNode->hasAttribute('key') )
				{
					$Name = $ChildNode->getAttribute('key');
					$Name = strtolower($Name);

					$Data[$Name] = $ChildNode->nodeValue;
				}
			}
		}
	}

	return $Data;
}

function checkConfig($AppId, array $Data)
{
	if ( $Data['appid'] != $AppId )
	{
		trigger_error('Wrong "appid" found. Please name the config-files according to the node\'s name.');
	}	

	switch( $Data['type'] )
	{
		case	'REPOSITORY':
				$RequiredParams = array(
					'appid',
					'host',
					'authenticationwebservice',
					'authenticationwebservice_wsdl',
					'permissionwebservice',
					'permissionwebservice_wsdl',
					'usagewebservice',
					'usagewebservice_wsdl',
					'alfresco_webservice_url',
				);
			break;

		case	'LMS':
				$RequiredParams = array(
					'appid',
					'host',
					'authenticationwebservice',
					'authenticationwebservice_wsdl',
					'permissionwebservice',
					'permissionwebservice_wsdl',
					'alfresco_webservice_url',
				);
			break;

		case	'SERVICE':
				$RequiredParams = array(
					'appid',
					'host',
					'authenticationwebservice',
					'authenticationwebservice_wsdl',
					'alfresco_webservice_url',
				);
			break;

		default:
			trigger_error('UNHANDLED TYPE.');
	}	

	foreach( $RequiredParams as $RequiredParam )
	{
		if ( empty($Data[$RequiredParam]) )
		{
			?><p><b>Missing config-param "<?php echo htmlentities($RequiredParam) ?>".</b></p><?php
		}
		else
		{
			?><p>Found config-param "<?php echo htmlentities($RequiredParam) ?>".</p><?php
		}		
	}
}

function getWsdl($AppId, array $Data)
{
	
}

if ( ! empty($_GET) )
{
	if ( empty($_GET['appid']) )
	{
		trigger_error('Missing request-param "appid".');
	}

	$AppId = $_GET['appid'];

	switch( $_GET['action'] )
	{
		case 'check':
			$Filename = $ConfigDir . DIRECTORY_SEPARATOR . 'app-' . $AppId . '.properties.xml';
			$Data = loadConfigFile($Filename);
			if ( ! $Data )
			{
				trigger_error('Error loading config for node "'.$AppId.'".');
			}	

			checkConfig($AppId, $Data);

			break;

		case 'soap':
			break;

		case 'wsdl':
			break;

		default:
			trigger_error('Missing request-param "action".');
	}
}

$DirHandle = opendir($ConfigDir);
if ( ! $DirHandle )
{
	trigger_error('Error opening config-dir.');
}

?>
<hr />
<table>
<thead>
	<tr>
		<td>Node</td>
		<td></td>
		<td></td>
		<td></td>
	</tr>
</thead>
<tbody>
<?php
while ( $DirEntry = readdir($DirHandle) )
{
	$Filename = $ConfigDir . DIRECTORY_SEPARATOR . $DirEntry;
	if ( is_file($Filename) )
	{
		if ( 'app-' == substr($DirEntry, 0, 4) )
		{
			$AppId = substr($DirEntry, 4, -15);
			?>
		<tr>
			<td>
				<?php echo htmlspecialchars($AppId) ?>
			</td>
			<td>
				<a href="check_config.php?appid=<?php echo urlencode($AppId) ?>&action=check" >check</a>
			</td>
			<td>
				<a href="check_config.php?appid=<?php echo urlencode($AppId) ?>&action=soap" >soap</a>
			</td>
			<td>
				<a href="check_config.php?appid=<?php echo urlencode($AppId) ?>&action=wsdl" >wsdl</a>
			</td>

		</tr>
			<?php
		}
	}
}
?>
</tbody>
</table>

